#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (c) 2010, miya All rights reserved.
#
#Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#
#* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#* Neither the name of the copyright holders nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys, os, math

def coef(s, e, c, n, x):
  d = (e - s) / float(n)
  return int(math.floor(s + d * x * math.pow(c, x - float(n)) + 0.5))

def make_matrix(s, e, c, n, p):
  n2 = n * 2 - 2
  for y in range(n):
    for x in range(n):
      sys.stdout.write(p + ',%d,%d' % (y * n + x, coef(s, e, c, n2, x + y)))
      sys.stdout.write('\n')

def make_matrix2(s, e, c, n):
  n2 = n * 2 - 2
  for y in range(n):
    for x in range(n):
      sys.stdout.write('%d' % coef(s, e, c, n2, x + y))
      if (x + y) < n2:
        sys.stdout.write(',')
    sys.stdout.write('\n')
  sys.stdout.write('\n')

# Lalfさんのエンコーダーの形式で量子化行列を生成
# make_matrix(左上の値, 右下の値, 曲線の係数(左上急勾配0.93<->1.2右下急勾配), 行列サイズ, 'パラメーター名')
# この形式を使用する場合は data_format = 1 にしてください。
data_format = 0
if (data_format == 1):
  print 'INTRA4X4_LUMA='
  make_matrix2(26, 62, 0.97, 4)
  print 'INTRA4X4_CHROMAU='
  make_matrix2(26, 62, 0.97, 4)
  print 'INTRA4X4_CHROMAV='
  make_matrix2(26, 62, 0.97, 4)
  print 'INTER4X4_LUMA='
  make_matrix2(30, 54, 0.97, 4)
  print 'INTER4X4_CHROMAU='
  make_matrix2(30, 54, 0.97, 4)
  print 'INTER4X4_CHROMAV='
  make_matrix2(30, 54, 0.97, 4)
  print 'INTRA8X8_LUMA='
  make_matrix2(26, 62, 0.97, 8)
  print 'INTER8X8_LUMA='
  make_matrix2(30, 54, 0.97, 8)

# SpursEngine SDK clubサンプルencoder用　量子化行列を生成
# make_matrix(左上の値, 右下の値, 曲線の係数(左上急勾配0.93<->1.2右下急勾配), 行列サイズ, 'パラメーター名')
if (data_format == 0):
  make_matrix(26, 62, 0.97, 4, 'Scaling List 4x4 Intra Y')
  make_matrix(26, 62, 0.97, 4, 'Scaling List 4x4 Intra Cb')
  make_matrix(26, 62, 0.97, 4, 'Scaling List 4x4 Intra Cr')
  make_matrix(30, 54, 0.97, 4, 'Scaling List 4x4 Inter Y')
  make_matrix(30, 54, 0.97, 4, 'Scaling List 4x4 Inter Cb')
  make_matrix(30, 54, 0.97, 4, 'Scaling List 4x4 Inter Cr')
  make_matrix(26, 62, 0.97, 8, 'Scaling List 8x8 Intra Y')
  make_matrix(30, 54, 0.97, 8, 'Scaling List 8x8 Inter Y')

sys.exit()
