#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (c) 2010, miya All rights reserved.
#
#Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#
#* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#* Neither the name of the copyright holders nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys, os, struct, re, codecs, commands, time, subprocess

def transcode(enc_profile, file_path_r, file_path_w):
  my_dir = os.path.dirname(os.path.abspath(sys.argv[0]))
  process1 = subprocess.Popen([my_dir + '/ench264.py ' + enc_profile + ' "' + file_path_r + '" "' + file_path_w + '"'], shell=True)
  process1.wait()
  return


def do_job(directory, directory_w, extension, enc_profile):
  # 指定ディレクトリ直下の指定拡張子のファイルに対して、同名の拡張子.mp4のファイルが存在しなければトランスコードして.mp4ファイルを作成。（つまり、まだトランスコードされていないファイルを全てトランスコードする。）
  full_directory = os.path.abspath(directory)
  full_directory_w = os.path.abspath(directory_w)

  # 指定ディレクトリが存在するか
  if not (os.path.isdir(full_directory) or os.path.isdir(full_directory_w)):
    print 'error:bad directory'
    sys.exit()

  files = os.listdir(full_directory)

  for filename in files:
    root, ext = os.path.splitext(filename)
    if (ext == extension):
      file_path_r = full_directory + '/' + filename
      file_path_w = full_directory_w + '/' + root + '.mp4'
      if os.path.isfile(file_path_r):
        if not os.path.exists(file_path_w):
          transcode(enc_profile, file_path_r, file_path_w)

  sys.exit()


# 指定ディレクトリの下位ディレクトリにあるファイルは処理しません。
# ディレクトリ階層を処理する場合はディレクトリごとにdo_job()を記述してください。
# do_job('動画のあるディレクトリ', '保存先ディレクトリ', '入力ファイルの拡張子', 'エンコードプロファイル名')
do_job('/media/disk/video', '/media/disk/mp4video', '.avi', 'p1280')

sys.exit()
